#utils data ------

# data in all contexts format ----- 
assert_Data_E1_En = function(D, X_n){ 
  #sanity
  sapply(1:length(D), function(di) {
    assert(X_n==length(D[[di]])-1)
    sapply(1:X_n, function(xi){
      assert(length(D[[di]])==X_n+1)
      assert(paste0("x", xi) %in% ls(D[[di]]))
      assert("y" %in% ls(D[[di]]))})
  })
}

rename_alphabetically = function(D){
  for (di in  1:length(D)){
    xmax = length(D[[di]])-1
    names(D[[di]]) = c(paste0("x", 1:xmax), "y")
  }
  return(D)
}
subset_collection  = function(D, X_sub){
  X_nms= paste0("x", X_sub)
  D_sub = list()
  
  for (di in 1:length(D)){
    Di_sub = c()
    
    for (i in 1:length(X_sub)){
      xi = X_sub[i]
      nm= paste0("x", xi)
      
      assert(nm %in% ls(D[[di]]))
      
      d_Xi = data.frame(D[[di]][[nm]])
      
      if(i==1) Di_sub = d_Xi
      else Di_sub = cbind(Di_sub, d_Xi)
    }
    Di_sub = cbind(Di_sub, D[[di]][["y"]])
    
    colnames(Di_sub) = c(X_nms, "y")
    di_nm = names(D)[di]
    D_sub[[di_nm]] = Di_sub
  }
  return(D_sub)
}


# other -----
standardize = function(D){
  lapply(D, function(Di) {
    Dis = data.frame(apply(Di, 2, function(row) 
      return(row/sd(row))))
    names(Dis) = names(Di)
    return(Dis)
  }
  )
}


sample_real = function (range, no) {
  if (no == 0)
    return()
  cs = runif(no, range[1], range[2])
  return(cs)
}

cint = function(x, alpha = 0.05)
   mean(x) + qt(1 - alpha / 2, length(x) - 1) * sd(x) / sqrt(length(x)) * c(-1, 1)


appd = function(lst, ent){
  lst[[length(lst)+1]] = ent
  return(lst)
}

subset_no = function(X_max_n, X_n){
  if(X_max_n==2) subset_no = choose(X_n-1, 1) +1 
  else  {
    if(X_max_n==2) subset_no = 1 #Todo
    else{
      subset_no = sum(sapply(2:X_max_n, function(i)
        return(choose(X_n-1, i-1)))) + 1 #number of generated subsets for each X. for score normalization.#1 for singleton subsets, ow choose co-members 
    }
  }
  return(subset_no)
}