

#  Generate data with gen_DAG_linear.R ------
# Data transforms --------------------

i = read_results_synthdata(method = "utigsp")

for (subdir in list("A_diagonal_shift/",
                    "B_groups_shift/",
                    "F_hard_interventions/",
                    "G_2hard_interventions/",
                    "E_mgroups_changes/")){
  
  basefilename = paste0("~/Vario/out/synthetic_graphs_vario/",subdir)
  out_createdir("~/Vario/out/synthetic_graphs_utigsp/") 
  out_createdir(paste0("~/Vario/out/synthetic_graphs_utigsp/",subdir))
  
  
 # out_createdir( "~/Vario/out/synthetic_out_jci_icp/")
  #out_createdir(paste0("~/Vario/out/synthetic_out_jci_icp/",subdir))
  cat("Make sure that Data is in ",basefilename)
  for(seed in 1:50){ 
   data = read.csv(file = paste0(basefilename, seed, "-data.csv"))
   data_c = list()
   for(context in 1:5){
     i1 = ((context-1) * 1000)+1
    i2 = (context*1000)
       data_ci = data[,c(1:5)][c(i1:i2),]
       data_c[[context]] =data_ci
       #write.csv(data_c, file = paste0("~/Vario/out/synthetic_graphs_cdnod/", subdir, seed, "-c",context, ".csv"), row.names = FALSE,col.names = FALSE)
   write.csv(data_ci, file = paste0("~/Vario/out/synthetic_graphs_utigsp/", subdir, seed, "-c",context, ".csv"), row.names = FALSE) #,col.names = FALSE)
  }
   
    
  }
  
   
}


# Run Python script utigsp_on_vario.R (Python 3.7 was used) ----
# Read results from out/synthetic_out_utigsp/subdir_nms: -----
for (subdir in list("A_diagonal_shift/",
                    "B_groups_shift/", 
                    "G_2hard_interventions/", 
                    "E_mgroups_changes/")){
  cat("\n\nResults for UTIGSP on", subdir)
  i = read_results_synthdata(method = "utigsp", subdir_nm = subdir)
}
