# Target Variables
# Sachs_data = load_Sachs()
# names(Sachs_data[[1]]) # Variables:
#[1] "praf"     "pmek"     "plcg"     "PIP2"     "PIP3"     "p44/42"   "pakts473" "PKA"      "PKC"      "P38"      "pjnk"  
 
# Target Variable ERK ----
quick_test_ERK = function(){ 
  ERK_id = 6  
  result_ERK = main_Vario_Sachs(ERK_id, X_max_n = 2) 
  #counts = match_graphs_Sachs(result_ERK$RESULT,
                              #result_ERK$x_named, 
                              #ERK_id)
  return(result_ERK)
}
RAF = function(set_n) reproduce_sachs_emp(1, set_n)
MEK = function(set_n) reproduce_sachs_emp(2, set_n)
PLCg = function(set_n) reproduce_sachs_emp(3, set_n)
PIP2 = function(set_n) reproduce_sachs_emp(4, set_n)
PIP3 = function(set_n) reproduce_sachs_emp(5, set_n)
ERK = function(set_n) reproduce_sachs_emp(6, set_n)
AKT = function(set_n) reproduce_sachs_emp(7, set_n)
PKA = function(set_n) reproduce_sachs_emp(8, set_n)
PKC = function(set_n) reproduce_sachs_emp(9, set_n)
P38 = function(set_n) reproduce_sachs_emp(10, set_n)
JNK = function(set_n) reproduce_sachs_emp(11, set_n)
 
reproduce_sachs_emp = function(yid, X_max_n=4){
  result = target_Vario_Sachs(yid, X_max_n)  
  #match_graphs_Sachs(result$RESULT,result$x_named, yid, X_max_n)
  return(result)
}


prune_edges = function (edges = list(res_1, res_2, res_3, res_4, res_5, res_6, res_7, res_8, res_9, res_10, res_11)){

edges_pruned  = edgeanalysis_prune(edges_simp, 
                                   eval_score_simp$edges_ordered, 
                                   eval_score_simp$adj_bin, xi_names, 
                                   consider_confounded = FALSE, 
                                   consider_3anc = FALSE)

edges_pruned_3anc = edgeanalysis_prune(edges_simp, 
                                       eval_score_simp$edges_ordered, 
                                       eval_score_simp$adj_bin, xi_names, 
                                       consider_confounded = FALSE, 
                                       consider_3anc = FALSE)


}


summarize_Sachs_adj = function(){
  #Read per-variable results from .rdata files:
  
  
  load("~/Vario/reproduce_sachs_emp/1-edges-npruned.RData")
  res1=rnk   
  load("~/Vario/reproduce_sachs_emp/2-edges-npruned.RData")
  res2=rnk   
  load("~/Vario/reproduce_sachs_emp/3-edges-npruned.RData")
  res3=rnk   
  load("~/Vario/reproduce_sachs_emp/4-edges-npruned.RData")
  res4=rnk   
  load("~/Vario/reproduce_sachs_emp/5-edges-npruned.RData")
  res5=rnk    
  load("~/Vario/reproduce_sachs_emp/6-edges-npruned.RData")
  res6=rnk   
  load("~/Vario/reproduce_sachs_emp/7-edges-npruned.RData")
  res7=rnk   
  load("~/Vario/reproduce_sachs_emp/8-edges-npruned.RData")
  res8=rnk   
  load("~/Vario/reproduce_sachs_emp/9-edges-npruned.RData")
  res9=rnk   
  load("~/Vario/reproduce_sachs_emp/10-edges-npruned.RData")
  res10=rnk  
  load("~/Vario/reproduce_sachs_emp/11-edges-npruned.RData")
  res11=rnk  
  
  results = list(res1, res2, res3, res4, res5, res6, res7, res8, res9, res10, res11)
  
  load("~/Vario/reproduce_sachs_emp/1-11-names.RData")
  xi_names = rnk
  eval_sachs_adj (results, xi_names, confints_8 = gen_confidence_intervals(8))
}

