#TODO evtl modf size no idea

create_h = function(size=100L) {
  return(new.env(hash=TRUE, parent = emptyenv(), size))
}

init_h = function(keys, vals){
  h = create_h()
  set_h(keys, vals)
  return(h)
}

`%at%` = function (key, e) { ifelse (exists(key, e), return(get (key, e)), stop("no entry: ", key)) }
`%inh%` = function (key, e) { exists(key, e) } # or %in% ls(e)

sub_h = function (name, h){
  hsub = create_h()
  assign(name, hsub, h)
  return(hsub)
}

#cur using only assign, get, exists
add_h =  assign #Vectorize(assign, vectorize.args = c("x", "value")) # warnings? using alt. f now
#add_h = function (key, val, h) { h[[key]] = val}
get_h = Vectorize(get, vectorize.args = "x")
exists_h = Vectorize(exists, vectorize.args = "x")






#TODO check why set_h behaves strange, does it have to do with strings 


## For Tables with groupsizes -> groups-> models -> xis ------
# show entries -----

display_group = function (Table, sz_i, attribute = NULL) {
  display = create_h()
  gnm = paste("G of ", sz_i, sep="")
  group1 = TRUE
  
  Group_keys = ls(Table[[gnm]])
  for (key in Group_keys){

    group = Table[[gnm]][[key]]
    
    Model_keys = ls(group$models)
    for(mkey in Model_keys) {
      if(group1) mdisplay = sub_h(mkey, display)
      else mdisplay = display[[mkey]]
      
      model = group$models[[mkey]]
      X_keys = ls(model$xis)
      for(xkey in X_keys) {
        cfs = model$xis[[xkey]]
        if(length(attribute )) cfs = cfs[[attribute]]
        add_h(paste(key, xkey, sep="-"), cfs, mdisplay)
      }
    }
group1 = FALSE
  }
  return(display)
}


display_h = function (Table, sz_i, m_i, x_i, attribute = NULL) {
  display = create_h()
  gnm = paste("G of ", sz_i, sep="")
  mnm = paste("m", m_i, sep="")
  xnm = paste("x", x_i, sep="")
  Group_keys = ls(Table[[gnm]])
  for (key in Group_keys){
    group = Table[[gnm]][[key]]
    cfs = group$models[[mnm]]$xis[[xnm]]
    if(length(attribute )) cfs = cfs[[attribute]]
    add_h(key, cfs, display)
  }
  return(display)
}

display_all_h = function (Table, m_i, x_i, attribute = NULL) {
  display = create_h()
  keys = ls(Table)
  for (k in keys){
    group = Table[[k]]
    sz_i = group$sz
    gnm = paste("G of ", sz_i, sep="")
    mnm = paste("m", m_i, sep="")
    xnm = paste("x", x_i, sep="")
    Group_keys = ls(group)
    for (key in Group_keys){
      subgroup = group[[key]]
      cfs = subgroup$models[[mnm]]$xis[[xnm]]
      if(length(attribute )) cfs = cfs[[attribute]]
      add_h(key, cfs, display)
    }
    
  }
  return(display)
}

#display = display_h(Table, 1, 1, 1, "coefficients")
#display = display_all_h(Table, 1, 1)
#Table$`G of 1`$D1$models$m1$xis$x1$coefficients


#-- tests ---

#add_h("D1", "test", Gof1)
#DataTable[["Gof1"]]
# 
# 
# DataTable = create_h()
# Gof1 = create_h()
# Gof2 = create_h()
# Gof3 = create_h()
# Gof4 = create_h()
# Gof5 = create_h()
# data  = testD$D1
# members = list("D1")
# add_h("data",data, Gof1)
# add_h("members",members, Gof1)
# 
# 
# set_h(c("Gof1", "Gof2", "Gof3", "Gof4", "Gof5"),c(Gof1, Gof2, Gof3, Gof4, Gof5), DataTable)
# 
# 


# get entries----- 

get_coefmap_h = function(Group_h, m_i, x_i) {
  m_nm = stringi::stri_c("m", m_i, sep = "") 
  x_nm = stringi::stri_c("x", x_i, sep = "") 
  return(Group_h$models[[m_nm]]$xis[[x_nm]])
}

get_coefs_h = function(Group_h, m_i, x_i) {
  c_h = get_coefmap_h(Group_h, m_i, x_i)
  return(c_h$coefficients)
}

get_intv_h =  function(Group_h, m_i, x_i, c_i) {
  c_h = get_coefmap_h(Group_h, m_i, x_i)
  l_h = c_h$lower[c_i]
  u_h = c_h$upper[c_i]
  return(c(l_h, u_h))
}

get_coef_h = function(Group_h, m_i, x_i, c_i) {
  return(get_coefs_h (Group_h, m_i, x_i)[c_i]) 
  #for coef hashmap: coefs = get_coefs_h (Group_h, m_i, x_i)
  #c_nm = levels(coefs_factor)[c_i]
  #  return(coefs[[c_nm]])
  
}

