#Vario-MDL on Sachs

####To show the outputs of Vario and VarioG on the Sachs et al. (2005) dataset:

-  `reproduced_edges_Vario.Rdata` includes for each variable in the network, all incoming edges found by Vario (local causal discovery). 
-  `reproduced_edges_VarioG.Rdata` includes all edges after the pruning step with  VarioG (causal network discovery).

- Vario: Use `eval_sachs_adj(pruning_step = FALSE)` to show all admissible edges.
- VarioG: Use `eval_sachs_adj(pruning_step = TRUE)` to show the final network reported in the paper.

####To reproduce from scratch (takes long):

- download the data [here](https://www.science.org/doi/10.1126/science.1105809).
- data should be in a folder  ~Vario/data_sachs/
- use `reproduce_vario_sachs()`.