
# Partition Discovery -------
show_decision_rates_basic(5,0,"run/")
show_decision_rates_mdl(5,0,"run/")

show_decision_rates_basic(8,0,"run/")
show_decision_rates_mdl(8,0,"run/")



for (subdir in list(list("A_diagonal_shift/", c(1)),
                    list( "B_groups_shift/", c(1,3)),
                    #list( "F_hard_interventions/", c(1)),
                    list( "G_2hard_interventions/", c(1,3)),
                    list("E_mgroups_changes/", c(1,4,5)))){
   
  subdir_nm = subdir[[1]]
  target_columns =  subdir[[2]]   
  target_columns = c(1) 


  cat("\n---------------\nJCI on ", subdir_nm,  "\n---------------\n")
  res=read_results_synthdata(mode =  "jci123", method = "fci", subdir_nm = subdir_nm, target_columns = target_columns )
  
  cat("\n---------------\nUTIGSP on ", subdir_nm,  "\n---------------\n")
  i = read_results_synthdata(method = "utigsp", subdir_nm = subdir_nm)
  
  for(mdl in list(TRUE, FALSE)){
    if(mdl) nm  = "MDL/"
    else nm = "Emp/"
    outdir_nm = "~/Vario/out/synthetic_out_vario/"
    variofiles = list(paste0(outdir_nm,subdir_nm, nm, "pi_5_2.txt"))
    if(subdir_nm != "A_diagonal_shift/")
      variofiles = list(paste0(outdir_nm,subdir_nm, nm, "pi_5_2.txt"),paste0(outdir_nm,subdir_nm, nm, "pi_5_3.txt"))
    
    cat("\n---------------\nVario ", nm, " on", subdir_nm,  "\n---------------\n")
    decision_rate_pi_causal(variofiles) 
  }
  
  
}

 


#Vario
